VERSION 5.00
Begin VB.Form RMCDemo 
   AutoRedraw      =   -1  'True
   Caption         =   "RMChart Demo"
   ClientHeight    =   9015
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   12450
   LinkTopic       =   "Form2"
   ScaleHeight     =   9015
   ScaleWidth      =   12450
   StartUpPosition =   3  'Windows-Standard
   Begin VB.VScrollBar VScroll1 
      Height          =   495
      Left            =   11160
      TabIndex        =   5
      Top             =   8400
      Visible         =   0   'False
      Width           =   255
   End
   Begin VB.PictureBox Picture2 
      BorderStyle     =   0  'Kein
      Height          =   495
      Left            =   1560
      ScaleHeight     =   33
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   49
      TabIndex        =   4
      Top             =   8280
      Visible         =   0   'False
      Width           =   735
   End
   Begin VB.Timer Timer1 
      Left            =   795
      Top             =   8265
   End
   Begin VB.PictureBox Picture1 
      BorderStyle     =   0  'Kein
      Height          =   8000
      Left            =   100
      ScaleHeight     =   533
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   805
      TabIndex        =   3
      Top             =   100
      Width           =   12075
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save"
      Height          =   375
      Left            =   4538
      TabIndex        =   2
      Top             =   8280
      Width           =   975
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "&Print"
      Height          =   375
      Left            =   5738
      TabIndex        =   1
      Top             =   8280
      Width           =   975
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "&Close"
      Height          =   375
      Left            =   6938
      TabIndex        =   0
      Top             =   8280
      Width           =   975
   End
   Begin VB.Menu mnGbased 
      Caption         =   "&Grid based"
      Begin VB.Menu mnSingleBars 
         Caption         =   "Single bars"
      End
      Begin VB.Menu mnGroupedBars 
         Caption         =   "Grouped Bars"
      End
      Begin VB.Menu mnStackedBars 
         Caption         =   "Stacked bars horizontal"
      End
      Begin VB.Menu mnFloatingBars 
         Caption         =   "Floating bars"
      End
      Begin VB.Menu mnBarsImage 
         Caption         =   "Bars with diff. colors and BgImage"
      End
      Begin VB.Menu mnNul1 
         Caption         =   "-"
      End
      Begin VB.Menu mnSimpleLine 
         Caption         =   "Line with a trend line"
      End
      Begin VB.Menu mnIndexedLine 
         Caption         =   "Indexed line"
      End
      Begin VB.Menu mnMissingData 
         Caption         =   "Lines with missing data"
      End
      Begin VB.Menu mnNull2 
         Caption         =   "-"
      End
      Begin VB.Menu mnBarsLines 
         Caption         =   "Bars and line"
      End
   End
   Begin VB.Menu mnNGBased 
      Caption         =   "&Not grid based"
      Begin VB.Menu mnDonut 
         Caption         =   "Donut with Image"
      End
      Begin VB.Menu mnPyramid 
         Caption         =   "Pyramid"
      End
      Begin VB.Menu mnPie 
         Caption         =   "Pie"
      End
   End
   Begin VB.Menu mnXY 
      Caption         =   "&XYSeries"
      Begin VB.Menu mnXYSimple 
         Caption         =   "Simple"
      End
      Begin VB.Menu mnXY2series 
         Caption         =   "Two series with 2 axes pairs"
      End
   End
   Begin VB.Menu mnMisc 
      Caption         =   "&Miscellaneous"
      Begin VB.Menu mnScroll 
         Caption         =   "Scroll chart"
      End
      Begin VB.Menu mnTimer 
         Caption         =   "Timer chart"
      End
      Begin VB.Menu mnFile 
         Caption         =   "Draw chart from file"
      End
      Begin VB.Menu mnDatastring 
         Caption         =   "Draw chart from data string"
      End
      Begin VB.Menu mnTranspChart 
         Caption         =   "Transparent chart"
      End
      Begin VB.Menu mnNul2 
         Caption         =   "-"
      End
      Begin VB.Menu mnZoom 
         Caption         =   "Zoom"
      End
      Begin VB.Menu mnMagnifier 
         Caption         =   "Magnifier"
      End
   End
End
Attribute VB_Name = "RMCDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const ID_RMC1 = 10001
Const ID_RMC2 = 10002
Dim nAllowChange As Boolean
Dim nIsZoom As Boolean
Dim nIsMagnifier As Boolean
Private Sub PRINTDEBUGN(ByVal n As Double)
    Dim nF As Long
    nF = FreeFile
    Open "DEBUG.DAT" For Append As #nF
    Print #nF, Time$
    Print #nF, Str$(n)
    Close #nF
End Sub


Private Sub cmdClose_Click()
    Unload Me
End Sub
Private Sub cmdPrint_Click()
    If MsgBox("Sent current chart to the default printer?", vbYesNo, "RMChart Demo") = vbYes Then
        RMC_Draw2Printer ID_RMC1
    End If
End Sub
Private Sub cmdSave_Click()
    RMC_Draw2File ID_RMC1, "RMChartDemo.png"
    MsgBox "Chart was saved as 'RMChartDemo.png' in the current directory"
End Sub
Private Sub Form_Load()
    Picture1.ScaleMode = 3 ' set the scale mode of the picture box to pixel!
End Sub
Private Sub Form_Unload(Cancel As Integer)
    ' always delete the chart when unloading the Form!!
    RMC_DeleteChart ID_RMC1
    If nIsMagnifier Then
        RMC_DeleteChart ID_RMC2
    End If
End Sub
Private Sub Picture1_Paint()
    ' this is necessary for repaint!
    RMC_Paint ID_RMC1
End Sub
Private Sub Picture2_Paint()
    ' this is necessary for repaint!
    RMC_Paint ID_RMC2
End Sub
Private Sub Picture1_MouseMove(Button As Integer, Shift As Integer, X As Single, y As Single)
    Dim nRetVal As Long
    Dim tINFO As tRMC_INFO
    
    ' In case we've added ToolTips, show them
    nRetVal = RMC_ShowToolTips(ID_RMC1, X, y)
    
    ' only necessary for the Zoom and Magnifier demos
    RMC_SetMouseClick ID_RMC1, RMC_MOUSEMOVE, X, y, tINFO
    If tINFO.nChartType = RMC_MAGNIFIER_MODE Then ' If in the magnifier demo
        ShowMagnification tINFO ' Show the magnification chart
    End If
End Sub
Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, y As Single)
    Dim tINFO As tRMC_INFO
    
    Select Case Button
        Case 1   ' Left Button
            If Shift = 0 Then
                ' get tINFO for the current X and Y position within the Picture-box
                RMC_SetMouseClick ID_RMC1, RMC_LBUTTONDOWN, X, y, tINFO
                If nAllowChange Then              ' if we are in the simple line demo
                    If tINFO.nGCol > 0 Then        ' if you've clicked into a grid column
                        ' change the current data to the data which corresponds to the current Y location
                        RMC_SetSeriesSingleData ID_RMC1, 1, 1, tINFO.nVirtData1, tINFO.nGCol, 0
                        
                        ' Refresh the trend line
                        Dim nFirst#, nLast#, nL&, nT&, nR&, nB&
                       ' Calc the trend and get the needed X/Y positions (nL,nT,nR,nB) for the line
                        RMC_CalcTrend ID_RMC1, 1, 1, nFirst, nLast, nL, nT, nR, nB
                        ' Add a CustomLine to show the trend:
                        RMC_CODash ID_RMC1, 1, nL, nT, nR, nB, RMC_LINE_FLAT_DASH, IIf(nFirst > nLast, Red, Green), False, 2, RMC_ANCHOR_NONE, RMC_ANCHOR_ARROW_CLOSED
                        ' Draw the "legend" for the trend line:
                        RMC_CODash ID_RMC1, 2, 470, 11, 500, 11, RMC_LINE_FLAT_DASH, IIf(nFirst > nLast, Red, Green), False, 2
                        RMC_COText ID_RMC1, 3, " Trend", 505, 5
                        
                        RMC_Draw ID_RMC1           ' (re)draw the chart with the new data and the trend line
                    End If
                End If
                If tINFO.nChartType = RMC_MAGNIFIER_MODE Then ' If in the magnifier demo
                    ShowMagnification tINFO ' Show the magnification chart
                End If
            ElseIf Shift = 1 Then  ' Shift
                RMC_SetMouseClick ID_RMC1, RMC_SHIFTLBUTTONDOWN, X, y, tINFO
            ElseIf Shift = 2 Then  ' Ctrl
                RMC_SetMouseClick ID_RMC1, RMC_CTRLLBUTTONDOWN, X, y, tINFO
                If tINFO.nChartType >= 0 Then ' No zoom or magnifier mode
                    ShowInfo tINFO                  ' show the infos we got from the DLL
                End If
            End If
        Case 2  ' Right Button
            If Shift = 0 Then
                RMC_SetMouseClick ID_RMC1, RMC_RBUTTONDOWN, X, y, tINFO
            ElseIf Shift = 1 Then  ' Shift
                RMC_SetMouseClick ID_RMC1, RMC_SHIFTRBUTTONDOWN, X, y, tINFO
            ElseIf Shift = 2 Then  ' Ctrl
                RMC_SetMouseClick ID_RMC1, RMC_CTRLRBUTTONDOWN, X, y, tINFO
            End If
    End Select
End Sub
Private Sub Picture1_MouseUp(Button As Integer, Shift As Integer, X As Single, y As Single)
    Dim tINFO As tRMC_INFO
    Select Case Button
        Case 1
            If Shift = 0 Then
                If (nIsZoom = True) Or (nIsMagnifier = True) Then
                    RMC_SetMouseClick ID_RMC1, RMC_LBUTTONUP, X, y, tINFO
                End If
            End If
    End Select
End Sub
Sub DoSettings()
    
    VScroll1.Visible = False
    With Picture1            ' Set the size for the main Picture control
        .Cls
        .Width = 11000
        .Height = 8000
    End With
    Picture2.Visible = False  ' Hide Picture2 ( which shows the magnification in the Magnifier demo), if visible
    If nIsMagnifier Then  ' If the Magnifier was the last active chart
        RMC_DeleteChart ID_RMC2  ' Delete the lower chart, which shows the magnification
    End If
    
    Timer1.Interval = 0  ' Stop the timer, if still running

    nAllowChange = False   ' Reset all flags
    nIsMagnifier = False
    nIsZoom = False
End Sub
Private Sub mnSingleBars_Click()
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
 
    DoSettings
 
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 0, 0, 600, 450, Azure, RMC_CTRLSTYLEFLAT, False, "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 5, -5, -5, "", False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add caption to region 1 *******************
    nRetVal = RMC_AddCaption(ID_RMC1, 1, "This is the chart's caption", Blue, Yellow, 11, True)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC1, 1, Beige, False, 0, 0, 0, 0, RMC_BICOLOR_LABELAXIS)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, RMC_DATAAXISLEFT, 0, 100, 11, 8, Black, Black, RMC_LINESTYLEDOT, 0, "", "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    sTemp = "Label 1*Label 2*Label 3*Label 4*Label 5"
    nRetVal = RMC_AddLabelAxis(ID_RMC1, 1, sTemp, 1, 5, RMC_LABELAXISBOTTOM, 8, Black, RMC_TEXTCENTER, Black, RMC_LINESTYLENONE, "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    '****** Read data values ******
    ReDim aData(4)
    aData(0) = 60: aData(1) = 70: aData(2) = 40: aData(3) = 60: aData(4) = 30
    nRetVal = RMC_AddBarSeries(ID_RMC1, 1, aData(0), 5, RMC_BARSINGLE, RMC_BAR_FLAT_GRADIENT2, False, CornflowerBlue, False, 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
    ' Set third bar's color to Red:
    RMC_SetSeriesColor ID_RMC1, 1, 1, Red, 3
 
    ' Add an average line to the chart:
    Dim nAverage As Double
    Dim nL&, nT&, nR&, nB&
    ReDim aXPoints(2) As Long
    ReDim aYPoints(2) As Long
    
    ' Calc the average
    RMC_CalcAverage ID_RMC1, 1, 1, nAverage, nL, nT, nR, nB
    ' Draw the average line
    RMC_CODash ID_RMC1, 1, nL, nT, nR, nB, RMC_FLAT_LINE, Green, False, 2
    ' Add a legend for the average line:
    aXPoints(0) = 480: aXPoints(1) = 565: aXPoints(2) = 565
    aYPoints(0) = 185: aYPoints(1) = 185: aYPoints(2) = 218
    RMC_COLine ID_RMC1, 2, aXPoints(0), aYPoints(0), 3, RMC_FLAT_LINE, Green, 0, 2, 0, RMC_ANCHOR_ARROW_OPEN
    RMC_COText ID_RMC1, 3, "Average: " + Format$(nAverage, "#.00"), 480, 169
        
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:
End Sub
Private Sub mnGroupedBars_Click()
    Dim i As Long
    Dim nC As Long
    Dim nDataCount As Long
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
    ReDim aData2(0) As Double
    ReDim aPPC(0) As Long
    ReDim aColor(0) As Long
    
    DoSettings
    
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 0, 0, 597, 447, AliceBlue, RMC_CTRLSTYLEFLATSHADOW, False, "", "Tahoma")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 5, -5, -5, "\0C", False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC1, 1, WhiteSmoke, False, 0, 0, 0, 0, RMC_BICOLOR_NONE)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, RMC_DATAAXISLEFT, 0, 100, 11, 8, Black, Black, RMC_LINESTYLESOLID, 0, "", "", "", RMC_TEXTCENTER)
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    sTemp = "2000*2001*2002*2003*2004"
    nRetVal = RMC_AddLabelAxis(ID_RMC1, 1, sTemp, 1, 5, RMC_LABELAXISBOTTOM, 8, Black, RMC_TEXTCENTER, Black, RMC_LINESTYLESOLID, "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add legend to region 1 *******************************
    sTemp = "Bananas*Apples*Cherries"
    nRetVal = RMC_AddLegend(ID_RMC1, 1, sTemp, RMC_LEGEND_TOP, LightYellow, RMC_LEGENDRECT, Black, 8, False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    '****** Read data values ******
    ReDim aData(4)
    aData(0) = 30#: aData(1) = 20#: aData(2) = 40#: aData(3) = 60#: aData(4) = 10#
    nRetVal = RMC_AddBarSeries(ID_RMC1, 1, aData(0), 5, RMC_BARGROUP, RMC_BAR_HOVER, False, Gold, False, 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 2 to region 1 *******************************
    '****** Read data values ******
    ReDim aData(4)
    aData(0) = 50#: aData(1) = 70#: aData(2) = 10#: aData(3) = 40#: aData(4) = 30#
    nRetVal = RMC_AddBarSeries(ID_RMC1, 1, aData(0), 5, RMC_BARGROUP, RMC_BAR_HOVER, False, LightGreen, False, 1, RMC_VLABEL_NONE, 2, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 3 to region 1 *******************************
    '****** Read data values ******
    ReDim aData(4)
    aData(0) = 40#: aData(1) = 10#: aData(2) = 30#: aData(3) = 20#: aData(4) = 80#
    nRetVal = RMC_AddBarSeries(ID_RMC1, 1, aData(0), 5, RMC_BARGROUP, RMC_BAR_HOVER, False, Salmon, False, 1, RMC_VLABEL_NONE, 3, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
 
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:

End Sub
Private Sub mnStackedBars_Click()
    Dim i As Long
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
    Dim tChart As tRMC_CHART
    Dim tRegion As tRMC_REGION
    Dim tCaption As tRMC_CAPTION
    Dim tLegend As tRMC_LEGEND
    Dim tGrid As tRMC_GRID
    Dim tDataAxis As tRMC_DATAAXIS
    Dim tLabelAxis As tRMC_LABELAXIS
    Dim tBarSeries As tRMC_BARSERIES
 
    DoSettings
        
    '************** Create the chart **********************
    tChart.nLeft = 0
    tChart.nTop = 0
    tChart.nWidth = 600
    tChart.nHeight = 450
    tChart.nBackColor = Bisque
    tChart.nCtrlStyle = RMC_CTRLSTYLE3DLIGHT
    tChart.sBgImage = ""
    nRetVal = RMC_CreateChartOnDCI(Picture1.hDC, ID_RMC1, tChart)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    tRegion.nLeft = 5
    tRegion.nTop = 10
    tRegion.nWidth = -5
    tRegion.nHeight = -5
    tRegion.sFooter = "this is the footer"
    tRegion.nShowBorder = False
    nRetVal = RMC_AddRegionI(ID_RMC1, tRegion)
    If nRetVal < 0 Then GoTo IsError
    '************** Add caption to region 1 *******************
    tCaption.sText = "Example of stacked bars"
    tCaption.nBackColor = Bisque
    tCaption.nTextColor = Black
    tCaption.nFontSize = 11
    tCaption.nIsBold = True
    nRetVal = RMC_AddCaptionI(ID_RMC1, 1, tCaption)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    tGrid.nGridBackColor = Cornsilk
    tGrid.nAsGradient = False
    tGrid.nLeft = 0
    tGrid.nTop = 0
    tGrid.nWidth = 0
    tGrid.nHeight = 0
    nRetVal = RMC_AddGridI(ID_RMC1, 1, tGrid)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    tDataAxis.nAlignment = RMC_DATAAXISBOTTOM
    tDataAxis.nMinValue = 0
    tDataAxis.nMaxValue = 50000
    tDataAxis.nTickCount = 11
    tDataAxis.nFontSize = 8
    tDataAxis.nTextColor = Black
    tDataAxis.nLineColor = Black
    tDataAxis.nLinestyle = RMC_LINESTYLESOLID
    tDataAxis.nDecimalDigits = 0
    tDataAxis.sUnit = "$"
    tDataAxis.sText = "This is an optional axis text"
    nRetVal = RMC_AddDataAxisI(ID_RMC1, 1, tDataAxis)
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    tLabelAxis.nCount = 1
    tLabelAxis.nTickCount = 6
    tLabelAxis.nAlignment = RMC_LABELAXISLEFT
    tLabelAxis.nFontSize = 8
    tLabelAxis.nTextColor = Black
    tLabelAxis.nTextAlignment = RMC_TEXTCENTER
    tLabelAxis.nLineColor = Black
    tLabelAxis.nLinestyle = RMC_LINESTYLESOLID
    tLabelAxis.sText = ""
    sTemp = "Label Nr. 1*Label Nr. 2*Label Nr. 3*Label Nr. 4*Label Nr. 5*Label Nr. 6"
    nRetVal = RMC_AddLabelAxisI(ID_RMC1, 1, sTemp, tLabelAxis)
    If nRetVal < 0 Then GoTo IsError
    '************** Add legend to region 1 *******************************
    tLegend.nLegendAlign = RMC_LEGEND_CUSTOM_UR
    tLegend.nLegendBackColor = LightYellow
    tLegend.nLegendStyle = RMC_LEGENDRECT
    tLegend.nLegendTextColor = Blue
    tLegend.nLegendFontSize = 8
    tLegend.nLegendIsBold = False
    sTemp = "Apples*Pears*Cherries*Strawberries"
    nRetVal = RMC_AddLegendI(ID_RMC1, 1, sTemp, tLegend)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    tBarSeries.nType = RMC_BARSTACKED
    tBarSeries.nStyle = RMC_COLUMN_FLAT
    tBarSeries.nIsLucent = False
    tBarSeries.nColor = DarkBlue
    tBarSeries.nIsHorizontal = True
    tBarSeries.nWhichDataAxis = 1
    tBarSeries.nValueLabelOn = RMC_VLABEL_NONE
    tBarSeries.nPointsPerColumn = 1
    tBarSeries.nHatchMode = RMC_HATCHBRUSH_OFF
    '****** Read data values ******
    ReDim aData(5)
    aData(0) = 10000: aData(1) = 10000: aData(2) = 16000: aData(3) = 12000
    aData(4) = 20000: aData(5) = 10000
    nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, aData(0), 6, tBarSeries)
    If nRetVal < 0 Then GoTo IsError
    ' Set CustomText for the ToolTips
    For i = 0 To 5
        RMC_SetCustomToolTipText ID_RMC1, 1, 1, i + 1, "Item: Apples" + Chr(13) + Chr(10) + "Value: " + Format$(aData(i), "#,#")
    Next
    '************** Add Series 2 to region 1 *******************************
    tBarSeries.nType = RMC_BARSTACKED
    tBarSeries.nStyle = RMC_COLUMN_FLAT
    tBarSeries.nIsLucent = False
    tBarSeries.nColor = DarkGreen
    tBarSeries.nIsHorizontal = True
    tBarSeries.nWhichDataAxis = 1
    tBarSeries.nValueLabelOn = RMC_VLABEL_NONE
    tBarSeries.nPointsPerColumn = 1
    tBarSeries.nHatchMode = RMC_HATCHBRUSH_OFF
    '****** Read data values ******
    ReDim aData(5)
    aData(0) = 5000: aData(1) = 7000: aData(2) = 4000: aData(3) = 15000: aData(4) = 10000
    aData(5) = 10000
    nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, aData(0), 6, tBarSeries)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 3 to region 1 *******************************
    tBarSeries.nType = RMC_BARSTACKED
    tBarSeries.nStyle = RMC_COLUMN_FLAT
    tBarSeries.nIsLucent = False
    tBarSeries.nColor = Maroon
    tBarSeries.nIsHorizontal = True
    tBarSeries.nWhichDataAxis = 1
    tBarSeries.nValueLabelOn = RMC_VLABEL_NONE
    tBarSeries.nPointsPerColumn = 1
    tBarSeries.nHatchMode = RMC_HATCHBRUSH_OFF
    '****** Read data values ******
    ReDim aData(5)
    aData(0) = 10000: aData(1) = 3000: aData(2) = 12000: aData(3) = 10000
    aData(4) = 5000: aData(5) = 20000
    nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, aData(0), 6, tBarSeries)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 4 to region 1 *******************************
    tBarSeries.nType = RMC_BARSTACKED
    tBarSeries.nStyle = RMC_COLUMN_FLAT
    tBarSeries.nIsLucent = False
    tBarSeries.nColor = DarkGoldenrod
    tBarSeries.nIsHorizontal = True
    tBarSeries.nWhichDataAxis = 1
    tBarSeries.nValueLabelOn = RMC_VLABEL_NONE
    tBarSeries.nPointsPerColumn = 1
    tBarSeries.nHatchMode = RMC_HATCHBRUSH_OFF
    '****** Read data values ******
    ReDim aData(5)
    aData(0) = 5000: aData(1) = 9000: aData(2) = 12000: aData(3) = 6000: aData(4) = 10000
    aData(5) = 5000
    nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, aData(0), 6, tBarSeries)
    If nRetVal < 0 Then GoTo IsError
 
    ' Activate ToolTips:
    nRetVal = RMC_AddToolTips(ID_RMC1, Picture1.hWnd, 100)
    
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:

End Sub
Private Sub mnFloatingBars_Click()
    Dim i As Long
    Dim nC As Long
    Dim nDataCount As Long
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
    ReDim aData2(0) As Double
    ReDim aPPC(0) As Long
    ReDim aColor(0) As Long
    Dim tChart As tRMC_CHART
    Dim tRegion As tRMC_REGION
    Dim tCaption As tRMC_CAPTION
    Dim tLegend As tRMC_LEGEND
    Dim tGrid As tRMC_GRID
    Dim tDataAxis As tRMC_DATAAXIS
    Dim tLabelAxis As tRMC_LABELAXIS
    Dim tBarSeries As tRMC_BARSERIES
    Dim tLineSeries As tRMC_LINESERIES
    Dim tGridlessSeries As tRMC_GRIDLESSSERIES
    Dim tXYAxis As tRMC_XYAXIS
    Dim tXYSeries As tRMC_XYSERIES
 
    DoSettings
    
    '************** Create the chart **********************
    tChart.nLeft = 0
    tChart.nTop = 0
    tChart.nWidth = 550
    tChart.nHeight = 300
    tChart.nBackColor = LightGray
    tChart.nCtrlStyle = RMC_CTRLSTYLE3DLIGHT
    tChart.sBgImage = ""
    tChart.sFontName = "Tahoma"
    nRetVal = RMC_CreateChartOnDCI(Picture1.hDC, ID_RMC1, tChart)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    tRegion.nLeft = 5
    tRegion.nTop = 5
    tRegion.nWidth = -5
    tRegion.nHeight = -5
    tRegion.sFooter = ""
    tRegion.nShowBorder = False
    nRetVal = RMC_AddRegionI(ID_RMC1, tRegion)
    If nRetVal < 0 Then GoTo IsError
    '************** Add caption to region 1 *******************
    tCaption.sText = "Birth of a Killer App"
    tCaption.nBackColor = Default
    tCaption.nTextColor = Black
    tCaption.nFontSize = 11
    tCaption.nIsBold = True
    nRetVal = RMC_AddCaptionI(ID_RMC1, 1, tCaption)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    tGrid.nGridBackColor = PaleGoldenrod
    tGrid.nAsGradient = True
    tGrid.nBiColor = RMC_BICOLOR_NONE
    tGrid.nLeft = 0
    tGrid.nTop = 0
    tGrid.nWidth = 0
    tGrid.nHeight = 0
    nRetVal = RMC_AddGridI(ID_RMC1, 1, tGrid)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    tDataAxis.nAlignment = RMC_DATAAXISBOTTOM
    tDataAxis.nMinValue = 1
    tDataAxis.nMaxValue = 13
    tDataAxis.nTickCount = 13
    tDataAxis.nFontSize = 8
    tDataAxis.nTextColor = Black
    tDataAxis.nLineColor = Black
    tDataAxis.nLinestyle = RMC_LINESTYLESOLID
    tDataAxis.nDecimalDigits = 0
    tDataAxis.nLabelAlignment = RMC_TEXTCENTER
    tDataAxis.sUnit = ""
    tDataAxis.sText = ""
    tDataAxis.sLabels = "04/01*04/02*04/03*04/04*04/05*04/06*04/07*04/08*04/09*04/10*04/11*04/12*05/01"
    nRetVal = RMC_AddDataAxisI(ID_RMC1, 1, tDataAxis)
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    tLabelAxis.nCount = 1
    tLabelAxis.nTickCount = 6
    tLabelAxis.nAlignment = RMC_LABELAXISLEFT
    tLabelAxis.nFontSize = 8
    tLabelAxis.nTextColor = Black
    tLabelAxis.nTextAlignment = RMC_TEXTCENTER
    tLabelAxis.nLineColor = Black
    tLabelAxis.nLinestyle = RMC_LINESTYLESOLID
    tLabelAxis.sText = ""
    sTemp = "Design*Development*Testing*Bug Fixing*Documentation*Marketing"
    nRetVal = RMC_AddLabelAxisI(ID_RMC1, 1, sTemp, tLabelAxis)
    If nRetVal < 0 Then GoTo IsError
    '************** Add legend to region 1 *******************************
    tLegend.nLegendAlign = RMC_LEGEND_CUSTOM_UR
    tLegend.nLegendBackColor = LightBlue
    tLegend.nLegendStyle = RMC_LEGENDRECT
    tLegend.nLegendTextColor = MediumBlue
    tLegend.nLegendFontSize = 8
    tLegend.nLegendIsBold = False
    sTemp = "Schedule*Reality"
    nRetVal = RMC_AddLegendI(ID_RMC1, 1, sTemp, tLegend)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    tBarSeries.nType = RMC_FLOATINGBARGROUP
    tBarSeries.nStyle = RMC_BAR_HOVER
    tBarSeries.nIsLucent = False
    tBarSeries.nColor = PaleGreen
    tBarSeries.nIsHorizontal = True
    tBarSeries.nWhichDataAxis = 1
    tBarSeries.nValueLabelOn = RMC_VLABEL_NONE
    tBarSeries.nPointsPerColumn = 1
    tBarSeries.nHatchMode = RMC_HATCHBRUSH_OFF
    '****** Read data values ******
    ReDim aData(11)
    aData(0) = 1: aData(1) = 3: aData(2) = 4: aData(3) = 6: aData(4) = 6
    aData(5) = 4: aData(6) = 7: aData(7) = 4: aData(8) = 9: aData(9) = 3
    aData(10) = 10: aData(11) = 3
    nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, aData(0), 12, tBarSeries)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 2 to region 1 *******************************
    tBarSeries.nType = RMC_FLOATINGBARGROUP
    tBarSeries.nStyle = RMC_BAR_HOVER
    tBarSeries.nIsLucent = False
    tBarSeries.nColor = OrangeRed
    tBarSeries.nIsHorizontal = True
    tBarSeries.nWhichDataAxis = 1
    tBarSeries.nValueLabelOn = RMC_VLABEL_NONE
    tBarSeries.nPointsPerColumn = 2
    tBarSeries.nHatchMode = RMC_HATCHBRUSH_OFF
    '****** Read data values ******
    ReDim aData(11)
    aData(0) = 1: aData(1) = 0.5: aData(2) = 1.5: aData(3) = 10.5: aData(4) = 12
    aData(5) = 1: aData(6) = 12: aData(7) = 1: aData(8) = 12.5: aData(9) = 0.5
    aData(10) = 2: aData(11) = 11
    nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, aData(0), 12, tBarSeries)
    If nRetVal < 0 Then GoTo IsError
 
    nRetVal = RMC_SetWatermark(RMC_USERWM, RMC_USERWMCOLOR, RMC_USERWMLUCENT, RMC_USERWMALIGN, RMC_USERFONTSIZE)
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub

IsError:

End Sub
Private Sub mnBarsImage_Click()
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
    ReDim aColor(0) As Long
    
    DoSettings
    
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 0, 0, 600, 500, Transparent, RMC_CTRLSTYLEIMAGE, False, "seasky.jpg")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 5, -5, -5, "", False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC1, 1, Transparent, False, 0, 0, 0, 0)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, RMC_DATAAXISLEFT, 0, 100, 11, 8, Chalk, Chalk, RMC_LINESTYLEDOT, 0, "", "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    sTemp = "Label 1*Label 2*Label 3*Label 4*Label 5"
    nRetVal = RMC_AddLabelAxis(ID_RMC1, 1, sTemp, 1, 5, RMC_LABELAXISBOTTOM, 8, Yellow, RMC_TEXTCENTER, Chalk, RMC_LINESTYLENONE, "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    '****** Read data values ******
    ReDim aData(4)
    aData(0) = 50: aData(1) = 70: aData(2) = 40: aData(3) = 60: aData(4) = 30
    nRetVal = RMC_AddBarSeries(ID_RMC1, 1, aData(0), 5, RMC_BARSINGLE, RMC_BAR_FLAT_GRADIENT2, True, Transparent, False, 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
    
'    uncomment the following lines to set individual colors for the bars:
'    ReDim aColor(4)
'    aColor(0) = Chalk: aColor(1) = Pink: aColor(2) = Gold: aColor(3) = Red: aColor(4) = Gray
'    RMC_SetSingleBarColors ID_RMC1, 1, aColor(0), 5
 
    ' Lets set some CustomToolTipTexts:
    RMC_SetCustomToolTipText ID_RMC1, 1, 1, 1, "First Bar" + Chr(13) + Chr(10) + "Value: 50" + Chr(13) + Chr(10) + "Color: Blue"
    RMC_SetCustomToolTipText ID_RMC1, 1, 1, 2, "Second Bar" + Chr(13) + Chr(10) + "Value: 70" + Chr(13) + Chr(10) + "Color: Green"
    RMC_SetCustomToolTipText ID_RMC1, 1, 1, 3, "Third Bar" + Chr(13) + Chr(10) + "Value: 40" + Chr(13) + Chr(10) + "Color: Red"
    RMC_SetCustomToolTipText ID_RMC1, 1, 1, 4, "Fourth Bar" + Chr(13) + Chr(10) + "Value: 60" + Chr(13) + Chr(10) + "Color: Yellow"
    ' Last bar gets no CustomText, so the default ToolTipText (=Value) is used
    
    ' Switch ToolTips on
    RMC_AddToolTips ID_RMC1, Picture1.hWnd, 100
 
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:

End Sub
Sub mnSimpleLine_Click()
    Dim i As Long
    Dim nC As Long
    Dim nDataCount As Long
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
    ReDim aData2(0) As Double
    ReDim aPPC(0) As Long
    ReDim aColor(0) As Long
 
    DoSettings
    nAllowChange = True    ' Allow changes with mouse click
    
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 0, 0, 600, 450, AliceBlue, RMC_CTRLSTYLEFLAT, False, "", "Tahoma")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 5, -5, -6, "Click with the left mousebutton into the grid!\C10", False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add caption to region 1 *******************
    nRetVal = RMC_AddCaption(ID_RMC1, 1, "Simple line", Aquamarine, Black, 10, True)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC1, 1, Beige, False, 0, 0, 0, 0)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, RMC_DATAAXISLEFT, 0, 100, 11, 8, Black, Black, RMC_LINESTYLESOLID, 0, "", "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    sTemp = ""
    nRetVal = RMC_AddLabelAxis(ID_RMC1, 1, sTemp, 1, 20, RMC_LABELAXISBOTTOM, 8, Black, RMC_TEXTCENTER, Black, RMC_LINESTYLESOLID, "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    '****** Read data values ******
    ReDim aData(19)
    aData(0) = 15: aData(1) = 25: aData(2) = 30: aData(3) = 22: aData(4) = 75
    aData(5) = 45: aData(6) = 65: aData(7) = 75: aData(8) = 40: aData(9) = 35
    aData(10) = 20: aData(11) = 45: aData(12) = 80: aData(13) = 90: aData(14) = 70
    aData(15) = 65: aData(16) = 25: aData(17) = 10: aData(18) = 30: aData(19) = 25
    nRetVal = RMC_AddLineSeries(ID_RMC1, 1, aData(0), 20, 0, 0, RMC_LINE, RMC_LINE_FLAT, RMC_LSTYLE_LINE_AREA, False, _
                                    Blue, RMC_SYMBOL_POINT, 1, RMC_VLABEL_DEFAULT, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
    nRetVal = RMC_SetWatermark(RMC_USERWM, RMC_USERWMCOLOR, RMC_USERWMLUCENT, RMC_USERWMALIGN, RMC_USERFONTSIZE)
    
    
    ' Now add a trend line:
    Dim nFirst#, nLast#, nL&, nT&, nR&, nB&

    ' Calc the trend and get the needed X/Y positions (nL,nT,nR,nB) for the line
    RMC_CalcTrend ID_RMC1, 1, 1, nFirst, nLast, nL, nT, nR, nB
    
    ' Add a CustomLine to show the trend:
    RMC_CODash ID_RMC1, 1, nL, nT, nR, nB, RMC_LINE_FLAT_DASH, IIf(nFirst > nLast, Red, Green), False, 2, RMC_ANCHOR_NONE, RMC_ANCHOR_ARROW_CLOSED
    
    ' Draw the "legend" for the trend line:
    RMC_CODash ID_RMC1, 2, 470, 11, 500, 11, RMC_LINE_FLAT_DASH, IIf(nFirst > nLast, Red, Green), False, 2
    RMC_COText ID_RMC1, 3, " Trend", 505, 5
    
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:
End Sub
Private Sub mnIndexedLine_Click()
    Dim nDataCount As Long
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
    ReDim aPPC(0) As Long
    Dim tChart As tRMC_CHART
    Dim tRegion As tRMC_REGION
    Dim tCaption As tRMC_CAPTION
    Dim tLegend As tRMC_LEGEND
    Dim tGrid As tRMC_GRID
    Dim tDataAxis As tRMC_DATAAXIS
    Dim tLabelAxis As tRMC_LABELAXIS
    Dim tLineSeries As tRMC_LINESERIES
 
    DoSettings
    
    '************** Create the chart **********************
    tChart.nLeft = 0
    tChart.nTop = 0
    tChart.nWidth = 600
    tChart.nHeight = 450
    tChart.nBackColor = PaleGreen
    tChart.nCtrlStyle = RMC_CTRLSTYLEFLATSHADOW
    tChart.sBgImage = ""
    nRetVal = RMC_CreateChartOnDCI(Picture1.hDC, ID_RMC1, tChart)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    tRegion.nLeft = 5
    tRegion.nTop = 10
    tRegion.nWidth = -5
    tRegion.nHeight = -5
    tRegion.sFooter = "data on a weekly basis. source: www.yahoo.com"
    tRegion.nShowBorder = False
    nRetVal = RMC_AddRegionI(ID_RMC1, tRegion)
    If nRetVal < 0 Then GoTo IsError
    '************** Add caption to region 1 *******************
    tCaption.sText = "Performance of DOW JONES, DAX and NASDAQ from January 2000 to end of June 2004"
    tCaption.nBackColor = PaleGreen
    tCaption.nTextColor = DarkBlue
    tCaption.nFontSize = 9
    tCaption.nIsBold = True
    nRetVal = RMC_AddCaptionI(ID_RMC1, 1, tCaption)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    tGrid.nGridBackColor = LightBlue
    tGrid.nAsGradient = True
    tGrid.nLeft = 0
    tGrid.nTop = 0
    tGrid.nWidth = 0
    tGrid.nHeight = 0
    nRetVal = RMC_AddGridI(ID_RMC1, 1, tGrid)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    tDataAxis.nAlignment = RMC_DATAAXISLEFT
    tDataAxis.nMinValue = 0
    tDataAxis.nMaxValue = 0
    tDataAxis.nTickCount = 11
    tDataAxis.nFontSize = 8
    tDataAxis.nTextColor = DarkBlue
    tDataAxis.nLineColor = DarkSlateGray
    tDataAxis.nLinestyle = RMC_LINESTYLEDOT
    tDataAxis.nDecimalDigits = 0
    tDataAxis.sUnit = "%"
    tDataAxis.sText = "2nd January 2000 = 100%"
    nRetVal = RMC_AddDataAxisI(ID_RMC1, 1, tDataAxis)
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    tLabelAxis.nCount = 1
    tLabelAxis.nTickCount = 5
    tLabelAxis.nAlignment = RMC_LABELAXISBOTTOM
    tLabelAxis.nFontSize = 8
    tLabelAxis.nTextColor = DarkBlue
    tLabelAxis.nTextAlignment = RMC_TEXTCENTER
    tLabelAxis.nLineColor = DarkSlateGray
    tLabelAxis.nLinestyle = RMC_LINESTYLEDOT
    tLabelAxis.sText = ""
    sTemp = "2000*2001*2002*2003*2004"
    nRetVal = RMC_AddLabelAxisI(ID_RMC1, 1, sTemp, tLabelAxis)
    If nRetVal < 0 Then GoTo IsError
    '************** Add legend to region 1 *******************************
    tLegend.nLegendAlign = RMC_LEGEND_CUSTOM_UR
    tLegend.nLegendBackColor = PaleTurquoise
    tLegend.nLegendStyle = RMC_LEGENDRECT
    tLegend.nLegendTextColor = DarkBlue
    tLegend.nLegendFontSize = 8
    tLegend.nLegendIsBold = False
    sTemp = "DOW JONES*DAX*NASDAQ"
    nRetVal = RMC_AddLegendI(ID_RMC1, 1, sTemp, tLegend)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    tLineSeries.nType = RMC_LINE_INDEXED
    tLineSeries.nStyle = RMC_LINE_FLAT
    tLineSeries.nLinestyle = RMC_LSTYLE_LINE
    tLineSeries.nIsLucent = False
    tLineSeries.nColor = Blue
    tLineSeries.nSeriesSymbol = RMC_SYMBOL_NONE
    tLineSeries.nWhichDataAxis = 1
    tLineSeries.nValueLabelOn = RMC_VLABEL_NONE
    tLineSeries.nHatchMode = RMC_HATCHBRUSH_OFF
    '****** Read points per column ******
    ReDim aPPC(0)
    aPPC(0) = 52
    '****** Read data values ******
    nDataCount = RMCvb_ReadDataFromFile(aData(), "dow00-04.csv", "234,1", "5", ",")
    If nDataCount < 0 Then GoTo IsError
    nRetVal = RMC_AddLineSeriesI(ID_RMC1, 1, aData(0), nDataCount, aPPC(0), 1, tLineSeries)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 2 to region 1 *******************************
    tLineSeries.nType = RMC_LINE_INDEXED
    tLineSeries.nStyle = RMC_LINE_FLAT
    tLineSeries.nLinestyle = RMC_LSTYLE_LINE
    tLineSeries.nIsLucent = False
    tLineSeries.nColor = Crimson
    tLineSeries.nSeriesSymbol = RMC_SYMBOL_NONE
    tLineSeries.nWhichDataAxis = 1
    tLineSeries.nValueLabelOn = RMC_VLABEL_NONE
    tLineSeries.nHatchMode = RMC_HATCHBRUSH_OFF
    '****** Read points per column ******
    ReDim aPPC(0)
    aPPC(0) = 52
    '****** Read data values ******
    nDataCount = RMCvb_ReadDataFromFile(aData(), "dax00-04.csv", "235,1", "5", ",")
    If nDataCount < 0 Then GoTo IsError
    nRetVal = RMC_AddLineSeriesI(ID_RMC1, 1, aData(0), nDataCount, aPPC(0), 1, tLineSeries)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 3 to region 1 *******************************
    tLineSeries.nType = RMC_LINE_INDEXED
    tLineSeries.nStyle = RMC_LINE_FLAT
    tLineSeries.nLinestyle = RMC_LSTYLE_LINE
    tLineSeries.nIsLucent = False
    tLineSeries.nColor = Black
    tLineSeries.nSeriesSymbol = RMC_SYMBOL_NONE
    tLineSeries.nWhichDataAxis = 1
    tLineSeries.nValueLabelOn = RMC_VLABEL_NONE
    tLineSeries.nHatchMode = RMC_HATCHBRUSH_OFF
    '****** Read points per column ******
    ReDim aPPC(0)
    aPPC(0) = 52
    '****** Read data values ******
    nDataCount = RMCvb_ReadDataFromFile(aData(), "nasdaq00-04.csv", "234,1", "5", ",")
    If nDataCount < 0 Then GoTo IsError
    nRetVal = RMC_AddLineSeriesI(ID_RMC1, 1, aData(0), nDataCount, aPPC(0), 1, tLineSeries)
    If nRetVal < 0 Then GoTo IsError
 
     ' Add some CustomObjects
    RMC_COText ID_RMC1, 1, "09/11/2001", 287, 117, 80, 22, RMC_BOX_NONE, LightGreen, 0, 150, 0, 0, "CB"
    RMC_CODash ID_RMC1, 2, 327, 141, 250, 225, RMC_FLAT_LINE, LightGreen, 0, 2, 0, RMC_ANCHOR_ARROW_OPEN
    RMC_CODash ID_RMC1, 3, 327, 141, 250, 275, RMC_FLAT_LINE, LightGreen, 0, 2, 0, RMC_ANCHOR_ARROW_OPEN
    RMC_CODash ID_RMC1, 4, 327, 141, 250, 347, RMC_FLAT_LINE, LightGreen, 0, 2, 0, RMC_ANCHOR_ARROW_OPEN
 
    nRetVal = RMC_SetWatermark(RMC_USERWM, RMC_USERWMCOLOR, RMC_USERWMLUCENT, RMC_USERWMALIGN, RMC_USERFONTSIZE)
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:

End Sub
Sub AddMovingAverage(aData() As Double, ByVal nPeriod As Long, ByVal nColor As Long)
    Dim i&, X&
    Dim nCount&, nRetVal&, y&, z&
    Dim aData1() As Double
    Dim tLineSeries As tRMC_LINESERIES
    ReDim aPPC(0) As Long
    
    nCount = UBound(aData()) + 1
    ReDim aData1(1 To nCount)

    For i = 1 To nCount
        If i < nPeriod Then            ' If no data available for building the average
            aData1(i) = RMC_NO_DATA    ' add the "NoData" Symbol
        Else
            y = (i - nPeriod): z = i - 1
            For X = y To z
                aData1(i) = aData1(i) + aData(X)
            Next
            aData1(i) = aData1(i) / nPeriod
        End If
    Next

    tLineSeries.nType = RMC_LINE
    tLineSeries.nStyle = RMC_LINE_FLAT
    tLineSeries.nLinestyle = RMC_LSTYLE_SPLINE
    tLineSeries.nColor = nColor
    aPPC(0) = 52
    nRetVal = RMC_AddLineSeriesI(ID_RMC1, 1, aData1(1), nCount, aPPC(0), 1, tLineSeries)
End Sub
Private Sub mnMissingData_Click()
    Dim i As Long
    Dim nC As Long
    Dim nDataCount As Long
    Dim nDateCount As Long
    Dim nRetVal As Long
    Dim sTemp As String
    Dim aXPos() As Long
    Dim aYPos() As Long
    ReDim aData(0) As Double
    ReDim aDate(0) As String
    ReDim aPPC(0) As Long
     
    DoSettings
 
    ' Cause we need them for calculating the moving averages, we must read the closing values into an array.
    ' (Otherwise we simply could have used function RMC_SetSeriesDataFile())
    nDataCount = RMCvb_ReadDataFromFile(aData(), "dax00-06.csv", "-1,1", "5", ",")
    If nDataCount < 1 Then GoTo IsError
    ' And we need the date values from the file for building our Custom ToolTips (see below):
    nDateCount = RMCvb_ReadStringFromFile(aDate(), "dax00-06.csv", "-1,1", "1", ",")
    If nDateCount < 1 Then GoTo IsError
 
 
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 0, 0, 597, 447, AliceBlue, RMC_CTRLSTYLEFLAT, False, "", "Tahoma")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 5, -5, -5, "\0C", False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add caption to region 1 *******************
    nRetVal = RMC_AddCaption(ID_RMC1, 1, "DAX on a weekly base with two moving averages and different ToolTips", Default, DarkBlue, 9, True)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC1, 1, WhiteSmoke, False, 0, 0, 0, 0, RMC_BICOLOR_NONE)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    sTemp = "2000**2400**2800**3200**3600**4000**4400**4800**5200**5600**6000**6400**6800**7200**7600**8000"
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, RMC_DATAAXISLEFT, 2000, 8000, 31, 8, Black, Black, RMC_LINESTYLESOLID, 0, "", "", sTemp, RMC_TEXTCENTER)
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    sTemp = "2000*2001*2002*2003*2004*2005*2006"
    nRetVal = RMC_AddLabelAxis(ID_RMC1, 1, sTemp, 1, 7, RMC_LABELAXISBOTTOM, 8, Black, RMC_TEXTCENTER, Black, RMC_LINESTYLESOLID, "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    aPPC(0) = 52
    '****** Read data values ******
    nRetVal = RMC_AddLineSeries(ID_RMC1, 1, aData(0), 357, aPPC(0), 1, RMC_LINE, RMC_LINE_FLAT, RMC_LSTYLE_LINE, False, _
                                    Navy, RMC_SYMBOL_NONE, 1, RMC_VLABEL_NONE, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
    
    ' Build CustomToolTipTexts for the first series and add them
    For i = 1 To nDataCount ' Number of closing values
        sTemp = "Date: " + aDate(i - 1) + Chr(13) + Chr(10) + "Close: " + Format(aData(i - 1), "0.00")
        RMC_SetCustomToolTipText ID_RMC1, 1, 1, i, sTemp
    Next
    
    '************** Add Series 2 and Series 3 to region 1 *******************************
    AddMovingAverage aData(), 20, Red    ' Add a moving average, which comprises 20 data points ...
    AddMovingAverage aData(), 50, Green  ' ... and one which comprises 50 data points
    
    '************** Add CustomObjects *******************************
    nRetVal = RMC_CODash(ID_RMC1, 1, 74, 69, 193, 69, RMC_FLAT_LINE, Red, 0, 2, RMC_ANCHOR_ARROW_OPEN, RMC_ANCHOR_NONE)
    nRetVal = RMC_COText(ID_RMC1, 2, "Period = 20", 195, 61, 0, 0, RMC_BOX_NONE, Default, Blue, 255, RMC_LINE_HORIZONTAL, Black, "08BC")
    nRetVal = RMC_CODash(ID_RMC1, 3, 125, 94, 193, 94, RMC_FLAT_LINE, Green, 0, 2, RMC_ANCHOR_ARROW_OPEN, RMC_ANCHOR_NONE)
    nRetVal = RMC_COText(ID_RMC1, 4, "Period = 50", 195, 87, 0, 0, RMC_BOX_NONE, Default, Blue, 255, RMC_LINE_HORIZONTAL, Black, "08BC")
    sTemp = "Move the mouse pointer over the blue line to see the CustomToolTips."
    sTemp = sTemp + Chr(13) + Chr(10) + "Both average lines have standard ToolTips."
    nRetVal = RMC_COText(ID_RMC1, 5, sTemp, 300, 50, 250, 65, RMC_BOX_GRADIENTH_SHADOW, PowderBlue, PowderBlue, 255, RMC_LINE_HORIZONTAL, Black, "09C")

    ' Activate the ToolTips:
    nRetVal = RMC_AddToolTips(ID_RMC1, Picture1.hWnd, 100)
        
    ' Draw the chart
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:
    MsgBox "Error while reading from file 'dax00-06.csv'"
End Sub
Private Sub mnBarsLines_Click()
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
 
    DoSettings
    
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 0, 0, 670, 450, CornflowerBlue, RMC_CTRLSTYLEFLATSHADOW, False, "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 10, -5, -5, "data source: F.A.Z", False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add caption to region 1 *******************
    nRetVal = RMC_AddCaption(ID_RMC1, 1, "The world's 10 biggest industrial companies 2003", Coral, FloralWhite, 12, True)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC1, 1, Azure, True, 0, 0, 0, 0)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, RMC_DATAAXISLEFT, 100000, 250000, 11, 9, Cornsilk, Black, RMC_LINESTYLESOLID, 0, "$", "Total turnover in Mill. Dollar")
    If nRetVal < 0 Then GoTo IsError
    '************** Add second data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, RMC_DATAAXISRIGHT, 0, 0, 0, 0, 0, 0, 0, 2, "%", "Net operating margin")
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    sTemp = "Exxon Mobil*Royal Dutch / Shell*BP*General Motors*Daimler Chrysler*Ford Motor*Toyota Motor*General E"
    sTemp = sTemp + "lectric*TOTAL*Chevron Texaco"
    nRetVal = RMC_AddLabelAxis(ID_RMC1, 1, sTemp, 1, 10, RMC_LABELAXISBOTTOM, 8, Cornsilk, RMC_TEXTCENTER, Black, RMC_LINESTYLESOLID, "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    '****** Read data values ******
    ReDim aData(9)
    aData(0) = 242365: aData(1) = 235598: aData(2) = 232571: aData(3) = 185524
    aData(4) = 170457: aData(5) = 164196: aData(6) = 149321: aData(7) = 132797
    aData(8) = 130067: aData(9) = 119703
    nRetVal = RMC_AddBarSeries(ID_RMC1, 1, aData(0), 10, RMC_BARSINGLE, RMC_BAR_FLAT_GRADIENT2, False, Gold, False, 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 2 to region 1 *******************************
    '****** Read data values ******
    ReDim aData(9)
    aData(0) = 8.9: aData(1) = 4.1: aData(2) = 4.4: aData(3) = 2.1: aData(4) = 0.3
    aData(5) = 0.3: aData(6) = 5.9: aData(7) = 11.3: aData(8) = 6.7: aData(9) = 6
    nRetVal = RMC_AddLineSeries(ID_RMC1, 1, aData(0), 10, 0, 0, RMC_LINE, RMC_LINE_CABLE, RMC_LSTYLE_LINE, False, _
                                    Green, RMC_SYMBOL_BULLET, 2, RMC_VLABEL_DEFAULT, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
 
    nRetVal = RMC_SetWatermark(RMC_USERWM, RMC_USERWMCOLOR, RMC_USERWMLUCENT, RMC_USERWMALIGN, RMC_USERFONTSIZE)
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:

End Sub
Private Sub mnDonut_Click()
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
    ReDim aColor(0) As Long
    Dim tChart As tRMC_CHART
    Dim tRegion As tRMC_REGION
    Dim tLegend As tRMC_LEGEND
    Dim tGridlessSeries As tRMC_GRIDLESSSERIES
 
    DoSettings
    
    '************** Create the chart **********************
    tChart.nLeft = 0
    tChart.nTop = 0
    tChart.nWidth = 600
    tChart.nHeight = 450
    tChart.nBackColor = Transparent
    tChart.nCtrlStyle = RMC_CTRLSTYLEIMAGETILED
    tChart.sBgImage = "paper.jpg"
    nRetVal = RMC_CreateChartOnDCI(Picture1.hDC, ID_RMC1, tChart)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    tRegion.nLeft = 5
    tRegion.nTop = 5
    tRegion.nWidth = -5
    tRegion.nHeight = -5
    tRegion.sFooter = ""
    tRegion.nShowBorder = False
    nRetVal = RMC_AddRegionI(ID_RMC1, tRegion)
    If nRetVal < 0 Then GoTo IsError
    '************** Add legend to region 1 *******************************
    tLegend.nLegendAlign = RMC_LEGEND_ONVLABELS
    tLegend.nLegendBackColor = Gainsboro
    tLegend.nLegendStyle = RMC_LEGENDNORECT
    tLegend.nLegendTextColor = Blue
    tLegend.nLegendFontSize = 8
    tLegend.nLegendIsBold = False
    sTemp = "Apples*Citrons*Bananas*Cherries"
    nRetVal = RMC_AddLegendI(ID_RMC1, 1, sTemp, tLegend)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    tGridlessSeries.nStyle = RMC_DONUT_GRADIENT
    tGridlessSeries.nPieAlignment = RMC_FULL
    tGridlessSeries.nExplodeMode = 0
    tGridlessSeries.nIsLucent = False
    tGridlessSeries.nValueLabelOn = RMC_VLABEL_TWIN
    tGridlessSeries.nHatchMode = RMC_HATCHBRUSH_OFF
    '****** Read color values ******
    ReDim aColor(3)
    aColor(0) = LightGreen
    aColor(1) = Yellow
    aColor(2) = Goldenrod
    aColor(3) = Crimson
    '****** Read data values ******
    ReDim aData(3)
    aData(0) = 40: aData(1) = 30: aData(2) = 60: aData(3) = 20
    nRetVal = RMC_AddGridlessSeriesI(ID_RMC1, 1, aData(0), 4, aColor(0), 4, tGridlessSeries)
    If nRetVal < 0 Then GoTo IsError
    
    RMC_COText ID_RMC1, 1, "With CustomObjects you can place text wherever you want!", _
               230, 175, 140, 100, RMC_BOX_NONE, 0, 0, 0, 0, Red, "12C"
     
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    
    Exit Sub
 
    
 
IsError:

End Sub
Private Sub mnPyramid_Click()
    Dim i As Long
    Dim nC As Long
    Dim nDataCount As Long
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
 
    DoSettings
    
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 10, 10, 600, 450, Transparent, _
                                  RMC_CTRLSTYLEFLAT, False, "", "Tahoma", Default)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 5, -5, -5, "", False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add legend to region 1 *******************************
    sTemp = "Apples*Bananas*Pears*Cherries"
    nRetVal = RMC_AddLegend(ID_RMC1, 1, sTemp, RMC_LEGEND_ONVLABELS, Default, RMC_LEGENDRECTSHADOW, _
                            Default, 8, False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    '****** Read data values ******
    ReDim aData(3)
    aData(0) = 30.25: aData(1) = 26.75: aData(2) = 15.89: aData(3) = 46.23
    nRetVal = RMC_AddGridlessSeries(ID_RMC1, 1, aData(0), 4, 0, 0, RMC_PYRAMIDE3, RMC_FULL, 0, _
                                    False, RMC_VLABEL_DEFAULT, RMC_HATCHBRUSH_OFF, 0)
    If nRetVal < 0 Then GoTo IsError
 
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:
End Sub
Private Sub mnPie_Click()
    Dim i As Long
    Dim nC As Long
    Dim nDataCount As Long
    Dim nRetVal As Long
    Dim sTemp As String
    Dim aData() As Double
    Dim aColor() As Long
 
    DoSettings
 
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 10, 10, 600, 450, Transparent, _
                                  RMC_CTRLSTYLEFLAT, False, "", "Tahoma", Default)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 5, -5, -5, "", False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    '****** Read color values ******
    ReDim aColor(3)
    aColor(0) = Maroon
    aColor(1) = MediumBlue
    aColor(2) = Crimson
    aColor(3) = Default
    '****** Read data values ******
    ReDim aData(3)
    aData(0) = 80: aData(1) = 50: aData(2) = 60: aData(3) = 30
    nRetVal = RMC_AddGridlessSeries(ID_RMC1, 1, aData(0), 4, aColor(0), 4, RMC_PIE_3D_GRADIENT, RMC_HALF_TOP, 0, False, RMC_VLABEL_NONE, RMC_HATCHBRUSH_OFF, 0)
    If nRetVal < 0 Then GoTo IsError
    '************** Add CustomObjects *******************************
    sTemp = "This is a 3D pie with semicircle alignment, tooltips, a custom text" + Chr(10) + Chr(13) + "and a discreet watermark."
    nRetVal = RMC_COText(ID_RMC1, 1, sTemp, 100, 270, 400, 50, RMC_BOX_3D_SHADOW, Moccasin, _
                         Default, 0, RMC_LINE_HORIZONTAL, Maroon, "09C")
    If nRetVal < 0 Then GoTo IsError
 
    nRetVal = RMC_SetWatermark("RMChart", AutumnOrange, 25, 1, RMC_USERFONTSIZE)
    
    ' Switch ToolTips on
    RMC_AddToolTips ID_RMC1, Picture1.hWnd, 100
    
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:

End Sub
Private Sub mnXYSimple_Click()
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
    ReDim aData2(0) As Double
 
    DoSettings
    
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 0, 0, 600, 450, SteelBlue, RMC_CTRLSTYLEFLAT, False, "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 5, -5, -5, "", False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add caption to region 1 *******************
    nRetVal = RMC_AddCaption(ID_RMC1, 1, "Simple XY chart", AliceBlue, Black, 10, True)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC1, 1, DarkBlue, False, 0, 0, 0, 0)
    If nRetVal < 0 Then GoTo IsError
    '************** Add first X axis to region 1 *****************************
    nRetVal = RMC_AddXAxis(ID_RMC1, 1, RMC_XAXISBOTTOM, 0, 100, 11, 8, BlanchedAlmond, White, RMC_LINESTYLENONE, 0, "", "X Axis")
    If nRetVal < 0 Then GoTo IsError
    '************** Add first Y axis to region 1 *****************************
    nRetVal = RMC_AddYAxis(ID_RMC1, 1, RMC_YAXISLEFT, 0, 100, 11, 8, BlanchedAlmond, Black, RMC_LINESTYLENONE, 0, "", "Y Axis")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    '****** Read X-data values ******
    ReDim aData(9)
    aData(0) = 10: aData(1) = 20: aData(2) = 30: aData(3) = 40: aData(4) = 50
    aData(5) = 60: aData(6) = 70: aData(7) = 80: aData(8) = 90: aData(9) = 10
    '****** Read Y-data values ******
    ReDim aData2(9)
    aData2(0) = 10: aData2(1) = 30: aData2(2) = 50: aData2(3) = 70: aData2(4) = 90
    aData2(5) = 70: aData2(6) = 50: aData2(7) = 30: aData2(8) = 10: aData2(9) = 10
    nRetVal = RMC_AddXYSeries(ID_RMC1, 1, aData(0), 10, aData2(0), 10, WhiteSmoke, RMC_XY_LINE_DASH, RMC_LSTYLE_LINE, RMC_SYMBOL_STAR, RMC_XAXISBOTTOM, RMC_YAXISLEFT, RMC_VLABEL_NONE)
    If nRetVal < 0 Then GoTo IsError
 
    nRetVal = RMC_SetWatermark(RMC_USERWM, RMC_USERWMCOLOR, RMC_USERWMLUCENT, RMC_USERWMALIGN, RMC_USERFONTSIZE)
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:

End Sub
Private Sub mnXY2series_Click()
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
    ReDim aData2(0) As Double
    ReDim aPPC(0) As Long
    ReDim aColor(0) As Long
    Dim tChart As tRMC_CHART
    Dim tRegion As tRMC_REGION
    Dim tCaption As tRMC_CAPTION
    Dim tLegend As tRMC_LEGEND
    Dim tGrid As tRMC_GRID
    Dim tXYAxis As tRMC_XYAXIS
    Dim tXYSeries As tRMC_XYSERIES
 
    DoSettings
    
    '************** Create the chart **********************
    tChart.nLeft = 0
    tChart.nTop = 0
    tChart.nWidth = 600
    tChart.nHeight = 450
    tChart.nBackColor = AliceBlue
    tChart.nCtrlStyle = RMC_CTRLSTYLEFLATSHADOW
    tChart.sBgImage = ""
    nRetVal = RMC_CreateChartOnDCI(Picture1.hDC, ID_RMC1, tChart)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    tRegion.nLeft = 5
    tRegion.nTop = 5
    tRegion.nWidth = -5
    tRegion.nHeight = -5
    tRegion.sFooter = ""
    tRegion.nShowBorder = False
    nRetVal = RMC_AddRegionI(ID_RMC1, tRegion)
    If nRetVal < 0 Then GoTo IsError
    '************** Add caption to region 1 *******************
    tCaption.sText = "Two XY series aligned to 2 different XY-axes pairs"
    tCaption.nBackColor = Blue
    tCaption.nTextColor = AntiqueWhite
    tCaption.nFontSize = 10
    tCaption.nIsBold = True
    nRetVal = RMC_AddCaptionI(ID_RMC1, 1, tCaption)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    tGrid.nGridBackColor = Beige
    tGrid.nAsGradient = False
    tGrid.nLeft = 0
    tGrid.nTop = 0
    tGrid.nWidth = 0
    tGrid.nHeight = 0
    nRetVal = RMC_AddGridI(ID_RMC1, 1, tGrid)
    If nRetVal < 0 Then GoTo IsError
    '************** Add first X axis to region 1 *****************************
    tXYAxis.nAlignment = RMC_XAXISBOTTOM
    tXYAxis.nMinValue = 0
    tXYAxis.nMaxValue = 100
    tXYAxis.nTickCount = 11
    tXYAxis.nFontSize = 8
    tXYAxis.nTextColor = Blue
    tXYAxis.nLineColor = Blue
    tXYAxis.nLinestyle = RMC_LINESTYLEDOT
    tXYAxis.nDecimalDigits = 0
    tXYAxis.sUnit = ""
    tXYAxis.sText = "First X axis"
    tXYAxis.sLabels = ""
    nRetVal = RMC_AddXAxisI(ID_RMC1, 1, tXYAxis)
    If nRetVal < 0 Then GoTo IsError
    '************** Add first Y axis to region 1 *****************************
    tXYAxis.nAlignment = RMC_YAXISLEFT
    tXYAxis.nMinValue = 0
    tXYAxis.nMaxValue = 100
    tXYAxis.nTickCount = 11
    tXYAxis.nFontSize = 8
    tXYAxis.nTextColor = Blue
    tXYAxis.nLineColor = Blue
    tXYAxis.nLinestyle = RMC_LINESTYLEDOT
    tXYAxis.nDecimalDigits = 0
    tXYAxis.sUnit = ""
    tXYAxis.sText = "First Y axis"
    tXYAxis.sLabels = ""
    nRetVal = RMC_AddYAxisI(ID_RMC1, 1, tXYAxis)
    If nRetVal < 0 Then GoTo IsError
    '************** Add second X axis to region 1 *****************************
    tXYAxis.nAlignment = RMC_XAXISTOP
    tXYAxis.nMinValue = 0
    tXYAxis.nMaxValue = 10
    tXYAxis.nTickCount = 5
    tXYAxis.nFontSize = 8
    tXYAxis.nTextColor = Coral
    tXYAxis.nLineColor = Coral
    tXYAxis.nLinestyle = RMC_LINESTYLEDASH
    tXYAxis.nDecimalDigits = 2
    tXYAxis.sUnit = ""
    tXYAxis.sText = "Second X axis"
    tXYAxis.sLabels = ""
    nRetVal = RMC_AddXAxisI(ID_RMC1, 1, tXYAxis)
    If nRetVal < 0 Then GoTo IsError
    '************** Add second Y axis to region 1 *****************************
    tXYAxis.nAlignment = RMC_YAXISRIGHT
    tXYAxis.nMinValue = 0
    tXYAxis.nMaxValue = 10
    tXYAxis.nTickCount = 5
    tXYAxis.nFontSize = 8
    tXYAxis.nTextColor = Coral
    tXYAxis.nLineColor = Coral
    tXYAxis.nLinestyle = RMC_LINESTYLEDASH
    tXYAxis.nDecimalDigits = 2
    tXYAxis.sUnit = ""
    tXYAxis.sText = "Second Y axis"
    tXYAxis.sLabels = ""
    nRetVal = RMC_AddYAxisI(ID_RMC1, 1, tXYAxis)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    tXYSeries.nColor = DarkBlue
    tXYSeries.nStyle = RMC_XY_SYMBOL
    tXYSeries.nLinestyle = 0
    tXYSeries.nSeriesSymbol = RMC_SYMBOL_BULLET
    tXYSeries.nWhichXAxis = RMC_XAXISBOTTOM
    tXYSeries.nWhichYAxis = RMC_YAXISLEFT
    tXYSeries.nValueLabelOn = RMC_VLABEL_NONE
    '****** Read X-data values ******
    ReDim aData(4)
    aData(0) = 20: aData(1) = 30: aData(2) = 60: aData(3) = 70: aData(4) = 90
    '****** Read Y-data values ******
    ReDim aData2(4)
    aData2(0) = 40: aData2(1) = 20: aData2(2) = 70: aData2(3) = 10: aData2(4) = 60
    nRetVal = RMC_AddXYSeriesI(ID_RMC1, 1, aData(0), 5, aData2(0), 5, tXYSeries)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 2 to region 1 *******************************
    tXYSeries.nColor = Coral
    tXYSeries.nStyle = RMC_XY_SYMBOL
    tXYSeries.nLinestyle = 0
    tXYSeries.nSeriesSymbol = RMC_SYMBOL_DIAMOND
    tXYSeries.nWhichXAxis = RMC_XAXISTOP
    tXYSeries.nWhichYAxis = RMC_YAXISRIGHT
    tXYSeries.nValueLabelOn = RMC_VLABEL_DEFAULT
    '****** Read X-data values ******
    ReDim aData(4)
    aData(0) = 2.5: aData(1) = 4.5: aData(2) = 5.5: aData(3) = 7.5: aData(4) = 1
    '****** Read Y-data values ******
    ReDim aData2(4)
    aData2(0) = 7.5: aData2(1) = 5.5: aData2(2) = 5.5: aData2(3) = 2.5: aData2(4) = 5
    nRetVal = RMC_AddXYSeriesI(ID_RMC1, 1, aData(0), 5, aData2(0), 5, tXYSeries)
    If nRetVal < 0 Then GoTo IsError
 
    nRetVal = RMC_SetWatermark(RMC_USERWM, RMC_USERWMCOLOR, RMC_USERWMLUCENT, RMC_USERWMALIGN, RMC_USERFONTSIZE)
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:

End Sub
Private Sub VScroll1_Change()
    Dim nIndex&
    
    With VScroll1
        nIndex = .Value
    End With
    RMC_SetSeriesDataRange ID_RMC1, 1, 1, nIndex, nIndex + 20
    RMC_SetSeriesDataRange ID_RMC1, 1, 2, nIndex, nIndex + 20
    RMC_Draw ID_RMC1
End Sub
Private Sub VScroll1_Scroll()
    Dim nIndex&
    
    With VScroll1
        nIndex = .Value
    End With
    RMC_SetSeriesDataRange ID_RMC1, 1, 1, nIndex, nIndex + 20
    RMC_SetSeriesDataRange ID_RMC1, 1, 2, nIndex, nIndex + 20
    RMC_Draw ID_RMC1
End Sub
Private Sub mnScroll_Click()
    Dim i As Long
    Dim nC As Long
    Dim nDataCount As Long
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
    ReDim aData2(0) As Double
    ReDim aPPC(0) As Long
    ReDim aColor(0) As Long
 
 
    ' Shows the use of RMC_SetSeriesDataRange() in conjunction with a scroll bar.
    ' Setting of the data range for both series happens in above scroll events VScroll1_Change()
    ' and VScroll1_Scroll()
 
    DoSettings
 
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 0, 0, 650, 500, DarkTurquoise, RMC_CTRLSTYLEFLAT, False, "", "Tahoma")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 5, -5, -5)
    If nRetVal < 0 Then GoTo IsError
    '************** Add caption to region 1 *******************
    nRetVal = RMC_AddCaption(ID_RMC1, 1, "Random data", Default, Black, 13, True)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC1, 1, LightSkyBlue, True, 0, 0, 0, 0, RMC_BICOLOR_NONE)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, RMC_DATAAXISBOTTOM, 7000, 12000, 11, 8, Black, Black, RMC_LINESTYLESOLID, 0, "", "Data axis for the line series\11", "", RMC_TEXTCENTER)
    If nRetVal < 0 Then GoTo IsError
    '************** Add second data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, , 0, 30000, 0, 0, 0, 0, 0, 0, "", "Data axis for the bar series\11")
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    nRetVal = RMC_AddLabelAxis(ID_RMC1, 1, "", 1, 21, RMC_LABELAXISLEFT, 8, Black, RMC_TEXTCENTER, Black, RMC_LINESTYLESOLID, "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    ReDim aData(4999)
    For i = 0 To 4999
        aData(i) = RMC_RND(10000, 28000)    ' Get 5000 random data values
    Next
    aData(0) = 3000                       ' Mark first ...
    aData(4999) = 3000                 ' and last data point
    nRetVal = RMC_AddBarSeries(ID_RMC1, 1, aData(0), 5000, RMC_BARSINGLE, RMC_BAR_HOVER, False, LightGoldenrod, True, 2, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
    
    RMC_SetSeriesDataRange ID_RMC1, 1, 1, 1, 21 ' Set initial data range
    '************** Add Series 2 to region 1 *******************************
    For i = 0 To 4999
        aData(i) = RMC_RND(8000, 11000)  ' Get 5000 random data values
    Next
    aData(0) = 11500                      ' Mark first ...
    aData(4999) = 11500                ' and last data point
    nRetVal = RMC_AddLineSeries(ID_RMC1, 1, aData(0), 5000, 0, 0, RMC_LINE, , RMC_LSTYLE_LINE, False, _
                                    Red, RMC_SYMBOL_POINT_SMALL, 1, RMC_VLABEL_NONE, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
    RMC_SetSeriesDataRange ID_RMC1, 1, 2, 1, 21   ' Set initial data range
    
    nRetVal = RMC_Draw(ID_RMC1)
    
    With VScroll1
        .Top = 100
        .Left = 9860
        .Height = 7500
        .Min = 1
        .Max = 4980
        .LargeChange = 21
        .Visible = True
    End With
        
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:

End Sub

Private Sub mnTimer_Click()
    Dim i As Long
    Dim nC As Long
    Dim nDataCount As Long
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
    
    DoSettings
    
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 0, 0, 597, 447, Black, RMC_CTRLSTYLEFLAT, False, "", "Tahoma")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 2, 2, -2, -2, "\0C", False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC1, 1, Black, False, 0, 0, 0, 0, RMC_BICOLOR_NONE)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, RMC_DATAAXISLEFT, 0, 700, 8, 7, LimeGreen, DarkGreen, RMC_LINESTYLEDOT, 0, "", "", "", RMC_TEXTCENTER)
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    sTemp = ""
    nRetVal = RMC_AddLabelAxis(ID_RMC1, 1, sTemp, 1, 20, RMC_LABELAXISBOTTOM, 8, Black, RMC_TEXTCENTER, DarkGreen, RMC_LINESTYLESOLID, "")
    If nRetVal < 0 Then GoTo IsError
    
    ' Get 20 random values between 100 and 600 for the initial line
    ReDim aData(19)
    For i = 0 To 19
        aData(i) = RMC_RND(100, 600)
    Next
    nRetVal = RMC_AddLineSeries(ID_RMC1, 1, aData(0), 20, 0, 0, RMC_LINE, RMC_LINE_FLAT, RMC_LSTYLE_LINE, False, _
                                    LimeGreen, RMC_SYMBOL_NONE, 1, RMC_VLABEL_NONE, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
 
    nRetVal = RMC_SetWatermark(RMC_USERWM, RMC_USERWMCOLOR, RMC_USERWMLUCENT, RMC_USERWMALIGN, RMC_USERFONTSIZE)
    nRetVal = RMC_Draw(ID_RMC1)
    
    Timer1.Interval = 1
    
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:

End Sub
Private Sub Timer1_Timer()
    Dim i As Long
    Dim nData As Double
    
    If Timer1.Interval = 0 Then Exit Sub
    
    For i = 2 To 20
        RMC_GetData ID_RMC1, 1, 1, i, nData  ' Get data...
        RMC_SetSeriesSingleData ID_RMC1, 1, 1, nData, i - 1 ' ... shift it one position to the left...
    Next
    RMC_SetSeriesSingleData ID_RMC1, 1, 1, RMC_RND(100, 600), 20 ' ... and set a new random value on position 20
    RMC_Draw ID_RMC1     ' redraw the chart
End Sub
Private Sub mnFile_Click()
    Dim nRetVal As Long
    
    DoSettings
    
    nRetVal = RMC_CreateChartFromFileOnDC(Picture1.hDC, ID_RMC1, 0, 0, 0, "4 regions.rmc")
    If nRetVal < 0 Then GoTo IsError
    
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
    
IsError:
End Sub
Private Sub mnDatastring_Click()
    Dim sTemp As String
    Dim nRetVal As Long
    
    DoSettings
    
    sTemp = sTemp + "00003650|00004450|000051|000061|000071|00008-6697831|00009400|00011Tahoma|100011"
    sTemp = sTemp + "|1000310|1000410|10005-5|10006-5|1000910|100101|100111|100121|100131|100181|1002"
    sTemp = sTemp + "00|100217|1002215|100238|100272|100331|100341|100358|100378|100411|100482|100492"
    sTemp = sTemp + "|10051-6751336|10052-15132304|10053-983041|100541|100558|10056-16777077|10057-16"
    sTemp = sTemp + "777077|100586|10060-16777077|10061-1468806|100622|10180data source: www.federalr"
    sTemp = sTemp + "eserve.gov + www.ecb.int|10181Prime Rates in USA und Euroland|10183%|101871999*"
    sTemp = sTemp + "2000*2001*2002*2003*2004*2005*2006|110011|1100221|110035|1100434|110052|110063|1"
    sTemp = sTemp + "10073|1100970|1101312|110171|11019-16744448|1102115|110221|1102396|110262|110521"
    sTemp = sTemp + "2|110534.75*4.75*4.75*4.75*4.75*5*5*5.25*5.25*5.25*5.5*5.5*5.5*5.75*6*6*6.5*6.5*"
    sTemp = sTemp + "6.5*6.5*6.5*6.5*6.5*6.5*5.5*5.5*5*4.5*4*3.75*3.75*3.5*3*2.5*2*1.75*1.75*1.75*1.7"
    sTemp = sTemp + "5*1.75*1.75*1.75*1.75*1.75*1.75*1.75*1.25*1.25*1.25*1.25*1.25*1.25*1.25*1*1*1*1*"
    sTemp = sTemp + "1*1*1*1*1*1*1*1*1*1*1.25*1.5*1.75*2*2.25*2.25*2.5*2.75*2.75*3*3.25*3.25*3.5*3.75"
    sTemp = sTemp + "*3.75*4*4.25*4.5*4.5*4.75*4.75*5*5.25*5.25*5.25*5.25*5.25*5.25*5.25|120011|12002"
    sTemp = sTemp + "21|120035|1200434|120052|120063|120073|1200950|1201312|120171|12019-2448096|1202"
    sTemp = sTemp + "115|120221|1202396|120262|1205212|120533*3*3*2.5*2.5*2.5*2.5*2.5*2.5*2.5*3*3*3*3"
    sTemp = sTemp + ".25*3.5*3.75*3.75*4.25*4.25*4.5*4.5*4.75*4.75*4.75*4.75*4.75*4.75*4.75*4.5*4.5*4"
    sTemp = sTemp + ".5*4.25*3.75*3.75*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3."
    sTemp = sTemp + "25*2.75*2.75*2.75*2.5*2.5*2.5*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*"
    sTemp = sTemp + "2*2*2*2*2*2.25*2.25*2.25*2.5*2.5*2.5*2.75*2.75*3*3*3.25*3.25*3.5|010011|010054|0"
    sTemp = sTemp + "100721|01014-16744448|010222|01024216*287|01025109*109|010272|010283|010012|0100"
    sTemp = sTemp + "51|01010295|01011102|010191|01026USA (Federal Funds Rate)|010013|010054|0100721|"
    sTemp = sTemp + "01014-10496|010222|01024260*287|01025192*192|010272|010283|010014|010051|0101029"
    sTemp = sTemp + "5|01011185|010191|01026Euroland (Prime Rate)"

    nRetVal = RMC_CreateChartFromFileOnDC(Picture1.hDC, ID_RMC1, 0, 0, 0, sTemp)
 
    nRetVal = RMC_SetWatermark(RMC_USERWM, RMC_USERWMCOLOR, RMC_USERWMLUCENT, RMC_USERWMALIGN, RMC_USERFONTSIZE)
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:

End Sub
Private Sub mnTranspChart_Click()
    Dim i As Long
    Dim nC As Long
    Dim nDataCount As Long
    Dim nRetVal As Long
    Dim sTemp As String
    ReDim aData(0) As Double
    ReDim aData2(0) As Double
    ReDim aPPC(0) As Long
    ReDim aColor(0) As Long
 
    ' We don't clear the PictureBox this time bevor painting, so it will be painted over
    ' a probably underlying chart, which shows the "real" transparency of this chart.
 
    If nIsMagnifier Then  ' If the Magnifier was the last active chart
        RMC_DeleteChart ID_RMC2  ' Delete the lower chart, which shows the magnification
    End If
 
    Timer1.Interval = 0  ' Stop the timer, if still running
    Picture2.Visible = False  ' Hide Picture2 (Magnifier), if visible

    nAllowChange = False   ' Reset all flags
    nIsMagnifier = False
    nIsZoom = False
 
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 185, 115, 250, 200, Transparent, RMC_CTRLSTYLEFLAT, False, "", "Tahoma", Transparent)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 5, -5, -5, "\0C", False)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC1, 1, Transparent, False, 0, 0, 0, 0, RMC_BICOLOR_NONE)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    sTemp = ""
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, RMC_DATAAXISLEFT, 0, 100, 11, 8, Black, Black, RMC_LINESTYLENONE, 0, "", "", sTemp, RMC_TEXTCENTER)
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    sTemp = ""
    nRetVal = RMC_AddLabelAxis(ID_RMC1, 1, sTemp, 1, 4, RMC_LABELAXISBOTTOM, 8, Black, RMC_TEXTCENTER, Black, RMC_LINESTYLENONE, "")
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    '****** Read data values ******
    ReDim aData(3)
    aData(0) = 70: aData(1) = 20: aData(2) = 80: aData(3) = 30
    nRetVal = RMC_AddBarSeries(ID_RMC1, 1, aData(0), 4, RMC_BARSINGLE, RMC_COLUMN_FLAT, False, Maroon, False, 1, RMC_VLABEL_NONE, 1, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 2 to region 1 *******************************
    '****** Read data values ******
    ReDim aData(3)
    aData(0) = 30: aData(1) = 70: aData(2) = 40: aData(3) = 80
    nRetVal = RMC_AddLineSeries(ID_RMC1, 1, aData(0), 4, 0, 0, RMC_LINE, RMC_LINE_CABLE_SHADOW, RMC_LSTYLE_SPLINE, False, _
                                    MediumBlue, RMC_SYMBOL_NONE, 1, RMC_VLABEL_NONE, RMC_HATCHBRUSH_OFF)
    If nRetVal < 0 Then GoTo IsError
 
    nRetVal = RMC_SetWatermark(RMC_USERWM, RMC_USERWMCOLOR, RMC_USERWMLUCENT, RMC_USERWMALIGN, RMC_USERFONTSIZE)
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    Exit Sub
 
IsError:

End Sub
Private Sub mnZoom_Click()
    Dim nRetVal As Long
    Dim sTemp As String
    Dim aData() As Double
    Dim aPPC() As Long
 
    
    DoSettings
    
    Picture1.MousePointer = 11
 
    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 10, 10, 650, 500, 0, RMC_CTRLSTYLEFLAT)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 5, -5, -70)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC1, 1)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, RMC_DATAAXISLEFT, 0, 0, 11)
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    sTemp = "2000*2001*2002*2003*2004*2005*2006"
    nRetVal = RMC_AddLabelAxis(ID_RMC1, 1, sTemp, 1, 7, RMC_LABELAXISBOTTOM, 8, 0, RMC_TEXTCENTER)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    ReDim aPPC(0)
    aPPC(0) = 254
    
    nRetVal = RMC_AddLineSeries(ID_RMC1, 1, 0, 0, aPPC(0), 1, RMC_LINE, RMC_LINE_FASTLINE, RMC_LSTYLE_LINE, False, _
                                    Green)
    If nRetVal < 0 Then GoTo IsError
    nRetVal = RMC_SetSeriesDataFile(ID_RMC1, 1, 1, "dax00-06d.csv", "-1,0", "3", ",", 0)
    If nRetVal < 0 Then GoTo IsError

    '************** Add Series 2 to region 1 *******************************
    nRetVal = RMC_AddLineSeries(ID_RMC1, 1, 0, 0, aPPC(0), 1, RMC_LINE, RMC_LINE_FASTLINE, RMC_LSTYLE_LINE, False, _
                                    Red)
    If nRetVal < 0 Then GoTo IsError
    nRetVal = RMC_SetSeriesDataFile(ID_RMC1, 1, 2, "dax00-06d.csv", "-1,0", "4", ",", 0)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 3 to region 1 *******************************
    nRetVal = RMC_AddLineSeries(ID_RMC1, 1, 0, 0, aPPC(0), 1, RMC_LINE, RMC_LINE_FASTLINE, RMC_LSTYLE_LINE, False, _
                                    Blue)
    If nRetVal < 0 Then GoTo IsError
    nRetVal = RMC_SetSeriesDataFile(ID_RMC1, 1, 3, "dax00-06d.csv", "-1,0", "7", ",", 0)
    If nRetVal < 0 Then GoTo IsError
    nRetVal = RMC_AddLegend(ID_RMC1, 1, "High*Low*Close", RMC_LEGEND_TOP)
    If nRetVal < 0 Then GoTo IsError
    sTemp = "Draw a rectangle with the left mouse button pressed around the area, "
    sTemp = sTemp + "which shall be zoomed, then release the button." + Chr(13) + Chr(10) + "With a right mouse button click (backwards) and a Shift+"
    sTemp = sTemp + "right mouse button click (forwards) you can browse between multiple zoom states." + Chr(13) + Chr(10)
    sTemp = sTemp + "The middle mouse button redraws the original (unzoomed) chart."
    nRetVal = RMC_COText(ID_RMC1, 1, sTemp, 35, 435, 610, 60, RMC_BOX_FLAT_SHADOW, 0, _
                         0, 0, RMC_LINE_HORIZONTAL, 0, "00C")
    If nRetVal < 0 Then GoTo IsError
    nRetVal = RMC_Zoom(ID_RMC1, RMC_ZOOM_INTERNAL, Red, Blue, 100)
    If nRetVal < 0 Then GoTo IsError
    nRetVal = RMC_Draw(ID_RMC1)
    If nRetVal < 0 Then GoTo IsError
    
    nIsZoom = True
    
    Picture1.MousePointer = 0
    
    Exit Sub
 
IsError:
    Picture1.MousePointer = 0
End Sub
Private Sub ShowMagnification(tINFO As tRMC_INFO)
    Dim nFirst&, nLast&, nFirstCol&, nLastCol&, nColIndex&, nOldColIndex&
    Dim nCount&, nFirstHLObject&, y&, i&, z&
    Dim aPointsPerCol() As Long
    Dim tINFO2 As tRMC_INFO
    
    ' Called from Picture1_MouseMove() and Picture1_MouseDown()
    
    If tINFO.nChartType = RMC_MAGNIFIER_MODE Then ' If in magnifier mode (=rectangle gets moved)
        If tINFO.nData1 <> 0 Then     ' If rectangle is over the HighLow series
            nFirst = RMC_GetLowPart(tINFO.nData1)   ' Get first data index, which is covered by the rect
            nLast = RMC_GetHighPart(tINFO.nData1)   ' Get last data index, which is covered by the rect
            RMC_SetSeriesDataRange ID_RMC2, 1, 1, nFirst, nLast
            ' To keep it simple, we could now set the label axis to one column and show the HighLow bars evenly spread
            ' in this column, as it is always done, when using the internal zooming mode (check example "Zoom").
            ' Uncomment the next four lines to see the chart:
            ' RMC_SetLAXTickCount ID_RMC2, 1, 1    ' only one column on the label axis
            ' RMC_SetLAXLabelsRange ID_RMC2, 1, 0, 0 ' show no labels
            ' RMC_Draw ID_RMC2                     ' draw the magnified area chart
            ' Exit Sub
            
            ' But we want to show the HighLow objects in the column(s) of the label axis, where they belong to.
            ' so we must check each HighLow object for it's column index, and we must count, how many objects belong
            ' to each column:
            nCount = ((nLast - nFirst) + 1) / 4  ' How many HighLow objects do we have (one object has 4 data points!)
            ' nFirst is always the first one of the four data points, which build one HighLow object
            nFirstHLObject = Fix(nFirst / 4) + 1    ' So we can calculate, what's the index of the first HighLow object
            For i = 1 To nCount                  ' For each HighLow object
                RMC_GetINFO ID_RMC1, tINFO2, 1, 1, nFirstHLObject + (i - 1) ' Get the tRMC_INFO structure
                nColIndex = tINFO2.nGCol                ' ColumnIndex of the HighLow object
                If nFirstCol = 0 Then nFirstCol = nColIndex ' Mark the first label for the label axis
                If nColIndex > nOldColIndex Then        ' New ColumnIndex?
                    y = y + 1                           ' Incr Column count
                    If y = 1 Then
                        ReDim aPointsPerCol(1 To 1)     ' (Re)Dimension the PointsPerColumn-Array
                    Else
                        ReDim Preserve aPointsPerCol(1 To y)
                    End If
                    nOldColIndex = nColIndex
                End If
                aPointsPerCol(y) = aPointsPerCol(y) + 1 ' Increment the counter for the PointsPerColumn for this Column
            Next
            nLastCol = nColIndex                        ' Mark the last label for the label axis
            RMC_SetLAXTickCount ID_RMC2, 1, y           ' Set the number of columns
            RMC_SetSeriesPPColumnArray ID_RMC2, 1, 1, aPointsPerCol(1), y ' set the PointsPerColumn
            RMC_SetLAXLabelsRange ID_RMC2, 1, nFirstCol, nLastCol ' Set the range for the labels on the label axis
            RMC_Draw ID_RMC2                           ' Draw the magnified area chart
        
        Else
            
            ' Rectangle does not cover the HighLow series, so set data range to zero
            RMC_SetSeriesDataRange ID_RMC2, 1, 1, 0, 0
        End If
        RMC_Draw ID_RMC2
    End If
End Sub
Private Sub mnMagnifier_Click()
    Dim nRetVal As Long
    Dim sTemp As String
    Dim aData() As Double
    Dim aPPC() As Long
    
    VScroll1.Visible = False
    With Picture1               ' For the upper chart
        .Cls
        .MousePointer = 11
        .Width = 12000
        .Height = 3800
    End With
    With Picture2             ' For the lowe chart (=Magnification)
        .Left = 100
        .Top = 3900
        .Width = 12000
        .Height = 4300
        .Visible = True
    End With
    If nIsMagnifier Then  ' If the Magnifier was the last active chart
        RMC_DeleteChart ID_RMC2  ' Delete the lower chart, which shows the magnification
    End If
    
    Timer1.Interval = 0  ' Stop the timer, if still running
    nAllowChange = False   ' Reset all flags
    nIsMagnifier = False
    nIsZoom = False


    '************** Create the chart **********************
    nRetVal = RMC_CreateChartOnDC(Picture1.hDC, ID_RMC1, 0, 0, 800, 250, 0, RMC_CTRLSTYLEFLAT)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC1, 5, 5, -150, -5)
    If nRetVal < 0 Then GoTo IsError
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC1, 1)
    If nRetVal < 0 Then GoTo IsError
    '************** Add data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(ID_RMC1, 1, RMC_DATAAXISLEFT, 0, 0, 11)
    If nRetVal < 0 Then GoTo IsError
    '************** Add label axis to region 1 *****************************
    sTemp = "2000*2001*2002*2003*2004*2005*2006"
    nRetVal = RMC_AddLabelAxis(ID_RMC1, 1, sTemp, 1, 7)
    If nRetVal < 0 Then GoTo IsError
    '************** Add Series 1 to region 1 *******************************
    ReDim aPPC(0)
    aPPC(0) = 254
    
    nRetVal = RMC_AddHighLowSeries(ID_RMC1, 1, 0, 0, aPPC(0), 1)
    If nRetVal < 0 Then GoTo IsError
    nRetVal = RMC_SetSeriesDataFile(ID_RMC1, 1, 1, "dax00-06d.csv", "-1,0", "2-5", ",", 0)
    If nRetVal < 0 Then GoTo IsError

    sTemp = "Click with the left mouse button onto the chart and move the blue rectangle over the HighLow series. "
    sTemp = sTemp + "The magnification of this area is shown in the lower chart control." + Chr(13) + Chr(10) + Chr(13) + Chr(10)
    sTemp = sTemp + "Shift + right mouse click enlarges the rectangle, Shift + left mouse click makes it smaller."
    nRetVal = RMC_COText(ID_RMC1, 1, sTemp, 660, 10, 120, 220, RMC_BOX_FLAT_SHADOW, 0, _
                         0, 0, RMC_LINE_HORIZONTAL, 0, "00C")


    nRetVal = RMC_Magnifier(ID_RMC1, True, 20, Blue, 0, 100)

    nIsMagnifier = True
    
    '************** Create a second chart for the magnifier **********************
    nRetVal = RMC_CreateChartOnDC(Picture2.hDC, ID_RMC2, 0, 0, 800, 300)
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(ID_RMC2, 5, 5, -5, -5)
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(ID_RMC2, 1)
    '************** Add data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(ID_RMC2, 1, RMC_DATAAXISLEFT, 0, 0, 11, 8)
    '************** Add label axis to region 1 *****************************
    sTemp = "2000*2001*2002*2003*2004*2005*2006"
    nRetVal = RMC_AddLabelAxis(ID_RMC2, 1, sTemp, 1, 7)
    'nRetVal = RMC_AddLabelAxis(ID_RMC2, 1, "", 0, 0, RMC_LABELAXISBOTTOM, 8, 0, RMC_TEXTCENTER, 0, RMC_LINESTYLENONE, "")
    
    nRetVal = RMC_AddHighLowSeries(ID_RMC2, 1, 0, 0, 0, 0)
    nRetVal = RMC_SetSeriesDataFile(ID_RMC2, 1, 1, "dax00-06d.csv", "-1,0", "2-5", ",", 0)
    
    
    Picture1.MousePointer = 0
    nRetVal = RMC_Draw(ID_RMC1)  ' Draw the upper chart
    
    Exit Sub
 
IsError:
    Picture1.MousePointer = 0
End Sub
Private Sub ShowInfo(tINFO As tRMC_INFO)
    ' Is called from Sub Picture1_MouseDown every time you click with the left mousebutton onto the picture box
    Dim sInfo As String
    Dim CRLF As String
    Dim sTab As String
    
    CRLF = Chr(13) + Chr(10)
    sTab = Chr(9)
    
    sInfo = sInfo + "Info about the mousepointer:" + CRLF
    sInfo = sInfo + "------------------------------" + CRLF
    sInfo = sInfo + "X position: " + sTab + Str$(tINFO.nXPos) + CRLF _
                  + "Y position: " + sTab + Str$(tINFO.nYPos)
    If tINFO.nRegionIndex > 0 Then
        sInfo = sInfo + CRLF + CRLF + "Info about the region:" + CRLF
        sInfo = sInfo + "------------------------------" + CRLF
        sInfo = sInfo + "Regionindex:" + sTab + Str$(tINFO.nRegionIndex) + CRLF _
                      + "Left position:" + sTab + Str$(tINFO.nRLeft) + CRLF _
                      + "Top position:" + sTab + Str$(tINFO.nRTop) + CRLF _
                      + "Right position:" + sTab + Str$(tINFO.nRRight) + CRLF _
                      + "Bottom position:" + sTab + Str$(tINFO.nRBottom)
    End If
    If tINFO.nRegionIndex < 0 Then ' Special case: this is a CustomObject
      sInfo = sInfo + CRLF + CRLF + "Info about the CustomObject:" + CRLF
      sInfo = sInfo + "------------------------------" + CRLF
      sInfo = sInfo + "Index:" + sTab + sTab + Str$(Abs(tINFO.nRegionIndex)) + CRLF _
                    + "Type:" + sTab + sTab + Choose(tINFO.nChartType, "Text", "Box", "Circle", "Line", "Image", "Symbol", "Polygon") + CRLF _
                    + "Left position:" + sTab + Str$(tINFO.nRLeft) + CRLF _
                    + "Top position:" + sTab + Str$(tINFO.nRTop) + CRLF _
                    + "Right position:" + sTab + Str$(tINFO.nRRight) + CRLF _
                    + "Bottom position:" + sTab + Str$(tINFO.nRBottom)
    End If
    If tINFO.nGLeft + tINFO.nGRight > 0 Then
        sInfo = sInfo + CRLF + CRLF + "Info about the grid:" + CRLF
        sInfo = sInfo + "------------------------------" + CRLF
        sInfo = sInfo + "Left position:" + sTab + Str$(tINFO.nGLeft) + CRLF _
                      + "Top position:" + sTab + Str$(tINFO.nGTop) + CRLF _
                      + "Right position:" + sTab + Str$(tINFO.nGRight) + CRLF _
                      + "Bottom position:" + sTab + Str$(tINFO.nGBottom) + CRLF
        If tINFO.nGCol > 0 Then
            Select Case tINFO.nChartType
                Case RMC_BARSINGLE To RMC_HIGHLOW
                    sInfo = sInfo + "Column:" + sTab + sTab + Str$(tINFO.nGCol) + CRLF _
                                  + "Row:" + sTab + sTab + Str$(tINFO.nGRow)
                Case RMC_XYCHART
                    sInfo = sInfo + "Sector-index of 1. axes pair:" + sTab + Str$(tINFO.nGCol)
                    If tINFO.nGRow > 0 Then
                        sInfo = sInfo + CRLF + "Sector-index of 2. axes pair:" + sTab + Str$(tINFO.nGRow)
                    End If
            End Select
        End If
    End If
    If tINFO.nSeriesIndex > 0 Then
        sInfo = sInfo + CRLF + CRLF + "Info about the series:" + CRLF
        sInfo = sInfo + "------------------------------" + CRLF
        sInfo = sInfo + "Seriesindex:" + sTab + Str$(tINFO.nSeriesIndex) + CRLF
        sInfo = sInfo + "Dataindex:" + sTab + Str$(tINFO.nDataIndex) + CRLF
        If tINFO.nChartType = RMC_GRIDLESS Then
        Else
            sInfo = sInfo + "Left position:" + sTab + Str$(tINFO.nSLeft) + CRLF _
                          + "Top position:" + sTab + Str$(tINFO.nSTop) + CRLF _
                          + "Right position:" + sTab + Str$(tINFO.nSRight) + CRLF _
                          + "Bottom position:" + sTab + Str$(tINFO.nSBottom) + CRLF
            If tINFO.nChartType = RMC_HIGHLOW Then
                sInfo = sInfo + "Y-pos. Open point:" + sTab + Str$(tINFO.nSTop2) + CRLF _
                              + "Y-pos. Close point:" + sTab + Str$(tINFO.nSBottom2) + CRLF
            End If
        End If
        Select Case tINFO.nChartType
            Case RMC_BARSINGLE, RMC_BARGROUP, RMC_LINE, RMC_AREA, RMC_VOLUMEBAR, RMC_AREA_STACKED
                sInfo = sInfo + "Data value:" + sTab + Format$(tINFO.nData1, "0.00") + CRLF
            Case RMC_BARSTACKED, RMC_BARSTACKED100, RMC_LINE_INDEXED, RMC_AREA_INDEXED, RMC_GRIDLESS, RMC_AREA_STACKED100
                sInfo = sInfo + "Absolut data value:" + sTab + Format$(tINFO.nData1, "0.00") + CRLF
                sInfo = sInfo + "Percent data value:" + sTab + " " + Format$(tINFO.nData2, "0.00") + CRLF
            Case RMC_FLOATINGBAR, RMC_FLOATINGBARGROUP
                sInfo = sInfo + "Starting data:" + sTab + Format$(tINFO.nData1, "0.00") + CRLF
                sInfo = sInfo + "Length data:" + sTab + " " + Format$(tINFO.nData2, "0.00") + CRLF
            Case RMC_XYCHART
                sInfo = sInfo + "X-data value:" + sTab + Format$(tINFO.nData1, "0.00") + CRLF
                sInfo = sInfo + "Y-data value:" + sTab + Format$(tINFO.nData2, "0.00") + CRLF
            Case RMC_HIGHLOW
                sInfo = sInfo + "Open data:" + sTab + Format$(tINFO.nData1, "0.00") + CRLF
                sInfo = sInfo + "High data:" + sTab + Format$(tINFO.nData2, "0.00") + CRLF
                sInfo = sInfo + "Low data:" + sTab + Format$(tINFO.nData3, "0.00") + CRLF
                sInfo = sInfo + "Close data:" + sTab + Format$(tINFO.nData4, "0.00") + CRLF
        End Select
    End If
    If tINFO.nGLeft + tINFO.nGRight > 0 Then
        sInfo = sInfo + CRLF + CRLF + "Data value, which is correspondent" + CRLF _
                                      + "to this X/Y location:" + CRLF
        sInfo = sInfo + "------------------------------" + CRLF
        If tINFO.nChartType = RMC_XYCHART Then
            sInfo = sInfo + "X-data value of 1. axes pair: " + sTab + LTrim(Format$(tINFO.nVirtData1, "0.00")) + CRLF
            sInfo = sInfo + "Y-data value of 1. axes pair: " + sTab + LTrim(Format$(tINFO.nVirtData2, "0.00")) + CRLF
            If tINFO.nVirtData3 <> 0 And tINFO.nVirtData4 <> 0 Then
                sInfo = sInfo + "X-data value of 2. axes pair: " + sTab + LTrim(Format$(tINFO.nVirtData3, "0.00")) + CRLF
                sInfo = sInfo + "Y-data value of 2. axes pair: " + sTab + LTrim(Format$(tINFO.nVirtData4, "0.00")) + CRLF
            End If
        Else
            sInfo = sInfo + "Data value of the 1. data-axis: " + LTrim(Format$(tINFO.nVirtData1, "0.00")) + CRLF
            If tINFO.nVirtData2 <> 0 Then
                sInfo = sInfo + "Data value of the 2. data-axis: " + sTab + LTrim(Format$(tINFO.nVirtData2, "0.00")) + CRLF
            End If
        End If
    End If
    MsgBox sInfo, vbInformation, "RMChart Demo"
End Sub

